#define THREAD_USE_POSIX
#include "libtsctl.c"
#include "nettsctl.h"

void test00(volatile char *ptr) {
    ((volatile unsigned *)(ptr+0x34))[0] = 8;
}
void test01(volatile char *ptr) {
    ((volatile unsigned *)(ptr+0x30))[0] = 8;
}

void test0(volatile char *ptr) {
  ((volatile unsigned *)(ptr+0x30))[0] = 8;
  while (1) {
    test00(ptr);
    test01(ptr);
  }
}

int main(int argc,char *argv[]) {

  if (argc < 2) {
    return 1;
  }
  int n = atoi(argv[1]);
  if (n < 6) {
    Bus *bus6 = BusInit(6);
    Bus *bus7 = BusInit(7);
    DIORaw *dioraw = DIORawInit(1);
    DIO *dio = DIOInit(0);
    DIO *dio2 = DIOInit(2);
    DIO *dio5 = DIOInit(5);

    volatile char *ptr = ((MMapBus *)bus6)->Mem;
    volatile char *ptr30 = ptr + 0x30;
    volatile char *ptr34 = ptr + 0x34;
    pthread_mutex_t lock;

    switch (n) {
    case -6: // dio 5, 1.68Mhz
      dio5->SetAsync(dio5,35,1);
      while (1) {
	dio5->SetAsync(dio5,35,0);
	dio5->SetAsync(dio5,35,1);
      }

    case -5:
      ((volatile unsigned *)(ptr30))[0] = 8;
      pthread_mutex_init(&lock, NULL);
      while (1) {
	pthread_mutex_lock(&lock);
	((volatile unsigned *)(ptr34))[0] = 8;
	pthread_mutex_unlock(&lock);
	pthread_mutex_lock(&lock);
	((volatile unsigned *)(ptr30))[0] = 8;
	pthread_mutex_unlock(&lock);
      }

    case -4: // direct via separate pointers 7.6Mhz + lock/unlock
      ((volatile unsigned *)(ptr30))[0] = 8;
      while (1) {
	((AtmelAT91DIORaw *)dioraw)->sub->Lock(((AtmelAT91DIORaw *)dioraw)->sub,0,0);
	((volatile unsigned *)(ptr34))[0] = 8;
	((AtmelAT91DIORaw *)dioraw)->sub->Unlock(((AtmelAT91DIORaw *)dioraw)->sub,0,0);
	((AtmelAT91DIORaw *)dioraw)->sub->Lock(((AtmelAT91DIORaw *)dioraw)->sub,0,0);
	((volatile unsigned *)(ptr30))[0] = 8;
	((AtmelAT91DIORaw *)dioraw)->sub->Unlock(((AtmelAT91DIORaw *)dioraw)->sub,0,0);
      }
    case -3: // bus 6 via direct calls
      // 2.53Mhz versus 2.4Mhz for case 1, 3.1Mhz with true inlining
      while (1) {
	MMapBusPoke32(bus6,0x34,8);
	MMapBusPoke32(bus6,0x30,8);
      }
    case -2: // direct plus function call overhead
      // 4.1Mhz
      while (1) {
	test0(ptr);
      }
    case -1: // direct via separate pointers 7.6Mhz
      ((volatile unsigned *)(ptr30))[0] = 8;
      while (1) {
	((volatile unsigned *)(ptr34))[0] = 8;
	((volatile unsigned *)(ptr30))[0] = 8;
      }
    case 0: // direct    
      ((volatile unsigned *)(ptr+0x30))[0] = 8;
      while (1) {
	((volatile unsigned *)(ptr+0x34))[0] = 8;
	((volatile unsigned *)(ptr+0x30))[0] = 8;
      }
    case 1: // bus 6
      bus6->Poke32(bus6,0x30,8);
      while (1) {
	bus6->Poke32(bus6,0x34,8);
	bus6->Poke32(bus6,0x30,8);
      }
    case 2: // bus 7
      bus7->Poke32(bus7,0x30,8);
      while (1) {
	bus7->Poke32(bus7,0x34,8);
	bus7->Poke32(bus7,0x30,8);
      }
    case 3: // dioraw 1
      dioraw->DataSet(dioraw,3,1);
      while (1) {
	dioraw->DataSet(dioraw,3,0);
	dioraw->DataSet(dioraw,3,1);
      }
    case 4: // dio 2
      dio2->SetAsync(dio2,3,1);
      while (1) {
	dio2->SetAsync(dio2,3,0);
	dio2->SetAsync(dio2,3,1);
      }
    case 5: // dio 0
      dio->SetAsync(dio,35,1);
      while (1) {
	dio->SetAsync(dio,35,0);
	dio->SetAsync(dio,35,1);
      }
    }
  } else {
    tsctl *conn;

    conn = TsctlClient("127.0.0.1",NetModeBlocking);
    if (!conn) {
      perror("socket:");
      return 1;
    }
    DIO *dio = NetDIOInit(conn,5);
    dio->SetAsync(dio,35,1);
    while (1) {
      dio->SetAsync(dio,35,0);
      dio->SetAsync(dio,35,1);
    }
  }
}

// 396Mhz ~ 400Mhz = 2.5ns clock cycle
// direct access = 50ns
  // bus 7 = 500ns (cached)
  // bus 6 = 200ns (raw)
  // dioraw 1 = 800ns
  // dio 2 = 9000ns
  //DIORaw *dioraw = DIORawInit(1);
  // acquiring and release the bus lock seems to account for the long delay!
  // but how can this be, there should be no contention and it should be
  // fast!  additionally, only the first attempt should actually acquire
  // the real lock, right?  (erm, apparently not!)


// full cycle, looped

// 0 direct access = 152ns or 6.58Mhz
// 1 bus 6 = 414ns or 2.42Mhz
// 2 bus 7 = 1.06us or 943kHz
// 3 dioraw 1 = 1.75us or 572kHz
// 4 dio 2 = 6.1us or 165kHz
// 5 dio 0 = 7.1us or 142kHz
//  dio 0 pthreaded = 25us or 40kHz
// 6 dio 0 via tsctl server
/*
  4200 4200
   CPU  CPU
   PT   UT 
3 3.1M  3.1M
2 4.1M  4.1M
1 7.6M  7.6M
0 6.6M  6.6M 
1 2.9M  2.9M
2 1.1M  1.0k
3 683k  665k
4 72k   199k 272k
5 65k   167k 216k
6 450   N/A

We can gain almost 2x speed gain by caching direction register
if we also don't lock and unlock.  But we are null caching, so why
is locking and unlocking so expensive???

7.6Mhz = 131ns
1.4Mhz = 714ns
292ns

272k = 3767ns
492k = 2033ns
1734ns/2 = 867ns 

For some reason, we have a lot more locking overhead in our actual test case
than in our simulated example.

In any case, it appears that locking is very expensive, in part probably because
we have so many sub-routines and checks we go through.

Ideas on how can we solve this problem:
maybe we can strip locking out of libtsctl and add it back in at a higher layer.

we could also think of lock in terms of the bottom-most underlying resources needed to perform a task. in this context, a high-level lock would ultimately resolve to zero or move bottom-level locks.

in any case, what we need is a way to locks to optimize into the minimal code needed to perform the lock.  it is somewhat difficult to see how this can be accomplished in a layered environemnt.

dio->SetAsync(dio,35,state);
dio2->SetAsync(dio2,3,state);
dioraw->DataSet(dioraw,3,state);
bus7->Poke32(bus7,0x34,8);
bus6->Poke32(bus6,0x34,8);
((volatile unsigned *)(ptr+0x34))[0] = 8;

((volatile unsigned *)(ptr34))[0] = 8;

Another way to try to optimize would be to have a top-level DIO implementation which switches directly into the low-level peeks and pokes.

There is still a big question of how we might be able to compile code such that object oriented calls get inlined.  I just don't know of any way of doing it without an external tool that parses the code in question!

In dealing with locking, there is the need to balance between explicit and implicit locking.  Implicit locking means that if we don't obtain the needed lock before performing the operation, the lock is automatically acquired and then released.

One idea for how to speed implicit lock up might be to twiddle with the actual pointers so that if we are already locked we call directly into the locked routine, whereas if we don't lock we call a different routine.  This would be problematic in a threaded environment though, as if the same object was shared between threads there could be a race condition.

Alternately, if we don't perform the lock then we could just try to perform the operation without a lock.  This would yield better performance, but then we have to worry about cases when we really need to lock, such as when there is initialization to be performed (this would also apply to the SBus I think) or when we need to lock sub-resources.

Really the best approach might be a super-fast locking mechanism.

pthreads locking is not super-fast.  it is taking 600ns just to lock/unlock!

However we do it there is the potential issue of how we know whether or not the lock has been acquired or not!  In other words, how do we do this in a lock-safe manner which is also fast?

arguably, it is the object oriented call nature that gets in the way most of either inlining functions or creating macros either of which optimize significantly.
for parser automation this would require that we know that, for instance,
dio->sub corresponds to MMapBus, so that:
  dio->sub->Poke32(dio->sub,asOutput ? 0x10 : 0x14,1<<Num);
gets translated into
MMapBusPoke32(dio->sub,asOutput ? 0x10 : 0x14,1<<Num);

There is still the need to pass the object pointer though.

Can we avoid the need for a parser by constructing our code in a more simple
way, and then using that to auto-generate either result?

By this, I mean if we could define functions to perform DIO or Bus operations
in a more abstract language, and then use that to generate the C code for
either inline or object call code.

Unfortunately, it seems like the ideal syntax would really be closer to our
object notation.

There is more to the problem than just translating a call from a->b notation to
B() notation.  The other part is taking our object variables and turning them into static variables.

class Bus {
};
class MMapBus inherits Bus {
  volatile char *Mem;
  Init(int MemBase,int Page) {
    Mem = MemMap(MemBase,Pages);
  }
  void Poke32(int adrs,unsigned val)  {
    ((volatile unsigned *)(Mem+adrs))[0] = val;
  };
};

+

+
MMapBus bus1(0x30000000,1);
MMapBus bus2(0xFFFFF400,1);
=>
volatile char *bus1_Mem, *bus2_Mem;

bus1_Init() {
  bus1_Mem = MemMap(0x30000000,1);
}
bus2_Init() {
  bus2_Mem = MemMap(0xFFFFF400,1);
}

=>
static inline void bus1_Poke32(int adrs,unsigned val)  {
  ((volatile unsigned *)(bus1_Mem+adrs))[0] = val;
}

Ok, so given this there is a general picture of what we need to do.
1. instantiation definitions drive code generation

Bus bus1(0x30000000,1);
=>
Init(bus,int MemBase,int Page) {
  Mem = MemMap(MemBase,Pages);
}
=>
void *bus1_Init(int MemBase,int Page) {
  bus1_Mem = MemMap(MemBase,Pages);
}
=>
void *bus1_Init() {
  bus1_Mem = MemMap(0x30000000,1);
}

2. function definitions undergo code substitution
void Poke32(int adrs,unsigned val)  {
  ((volatile unsigned *)(Mem+adrs))[0] = val;
};
=>
static inline void bus1_Poke32(int adrs,unsigned val)  {
  ((volatile unsigned *)(bus1_Mem+adrs))[0] = val;
}

 */
